<html>

    <head>
        <title>JNIOR <?php = getRegistryString('$Model') ?> I/O</title>

        <script src="vendor/bowser/bowser_0.7.2.min.js"></script>

        <script src="jquery/jquery-1.9.0.min.js"></script>
        <script src="jquery/jquery-ui.min.js"></script>
        <link rel="stylesheet" href="jquery/jquery-ui.css" />

        <script src="base64.js"></script>
        <script src="md5.js"></script>


        <style>
            body {
                background: #dddddd;
                font-family:Arial;
                font-size: 12px;
            }

            h1 {
                color: #0099ff;
            }

            td {
                border-style:solid;
                border-width: 0px;
                border-color: #d0d0d0;
            }

            p {
                color: #555555;
            }

            .highlight {
                color: #0099ff;
                text-decoration: none;
            }

            .io-channel {
                border-style:solid;
                border-width: 1px;
                border-color: #cccccc;
                border-bottom: 0px;
                font-size: 12px;
                margin: 10px;
                margin-bottom: 0px;
                margin-top: 0px;
                background: #ffffff;
                width: 275px;
                height: 64px;
                -webkit-box-shadow: 0 10px 6px -6px #777;
                -moz-box-shadow: 0 10px 6px -6px #777;
                box-shadow: 0 10px 6px -6px #777;
            }

            .io-channel-empty {
                background: #dddddd;
                border-style:solid;
                border-width: 1px;
                border-color: #bbbbbb;
                border-bottom: 0px;
                margin: 10px;
                margin-bottom: 0px;
                margin-top: 0px;
                width: 275px;
                height: 64px;
                -webkit-box-shadow: 0 10px 6px -6px #777;
                -moz-box-shadow: 0 10px 6px -6px #777;
                box-shadow: 0 10px 6px -6px #777;
            }

            .io-description {
                font-weight: bold;
                padding-left:5px;
                background: #99CCFF;
                width: 48%;
                height: 50%;
                float:left;
                line-height: 32px;
                vertical-align: middle;
            }

            .io-state {
                float: left;
                width: 24%;
                height: 32px;
                line-height: 32px;
                vertical-align: middle;
                text-align: center;
            }

            .io-control {
                float: left;
                width: 24%;
                height: 32px;
                line-height: 32px;
                vertical-align: middle;
                text-align: center;
            }

            .io-counter {
                background: #ffffff;
                width: 50%;
                height: 32px;
                float:left;
                line-height: 32px;
                text-align: center;
                vertical-align: middle;
            }

            .io-usage {
                background: #ffffff;
                width: 50%;
                height: 32px;
                float:left;
                line-height: 32px;
                text-align: center;
                vertical-align: middle;
            }

            .io-closed {
                background-color:#66FF66;
            }

            .io-open {
                background-color:#FF6666;
            }

            .small-grey {
                color: #555555;
                font-size: 11px;
                padding: 15px;
                padding-top: 10px;
            }

            .ui-menu { position: absolute; width: 100px; }

            .lower-left-float {
                position : fixed;
                bottom   : 0px;
                left     : 20px;
            }

            .lower-right-float {
                position : fixed;
                bottom   : 0px;
                right    : 20px;
            }

            .left-float-menu {
                background: #ffffff;
                position : fixed;
                top      : -10px;
                left     : 0px;
                width    : 250px;
                height   : 110%;
                padding  : 20px;
                -webkit-box-shadow: 10px 0 6px -6px #777;
                -moz-box-shadow: 10px 0 6px -6px #777;
                box-shadow: 10px 0 6px -6px #777;
            }

            .overlay-text {
                color:#610000;
                font:72px arial,sans-serif;
                font-weight:bold;
                display: table-cell;
                vertical-align: middle;
                -moz-opacity: 1.0;
                opacity:1.0;
                filter:alpha(opacity=100);
            }

            .message-overlay {
                position: fixed;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                background: #f0f0f0;
                text-align:center;
                display:table;
                -moz-opacity: 0.7; /* makes the div transparent, so you have a cool overlay effect */
                opacity:0.7;
                filter:alpha(opacity=70);
            }
        </style>


        <script>
            if (bowser.msie && bowser.version <= 10) {
                alert("You are running an old browser.  You will be redirected to the Classic Configuration Page.  " +
                    "To take advantage of the new features on the 4 series please run a modern browser!");
                window.location = "/configure";
            }


            String.prototype.endsWith = function(suffix) {
                return this.indexOf(suffix, this.length - suffix.length) !== -1;
            };



            var inputCount = 8, outputCount = 8;
            var inputsReceived = 0, outputsReceived = 0;
            var _loggedIn = false;


            // build uri ------------------------------------------------------------------------------
            //  should use secure transport?
            var wsUri = "ws://";
            if (window.location.protocol == "https:")
                wsUri = "wss://";

            //  set host
            if (window.location.host != "")
                wsUri += window.location.host;
            else
                wsUri += prompt("Enter an IP Address to connect to", "10.0.0.70");
            console.log(wsUri);

            function init() {
                console.log(wsUri + "/builtin");
                testWebSocket();
            }

            function testWebSocket() {
                websocket = new WebSocket(wsUri);
                websocket.onopen = function(evt) {
                    onOpen(evt)
                };

                websocket.onclose = function(evt) {
                    onClose(evt)
                };

                websocket.onmessage = function(evt) {
                    onMessage(evt)
                };

                websocket.onerror = function(evt) {
                    onError(evt)
                };
            }



            function onOpen(evt) {
                $('#message-overlay').fadeOut();
                console.log("Connected");


                doSend('{"Message":null}');
            }


            function loggedIn() {

                var json = new Object();
                json.Message = "Registry Read";
                json.Keys = [
                    "$SerialNumber",
                    "$Model",
                    "Device/Desc",
                    "Externals/DeviceOrder/TypeFB_1",
                    "Externals/DeviceOrder/TypeFB_2"
                ]
                doSend(JSON.stringify(json));

//                for (var channel = 1; channel <= 12; channel++) {
//                    json = new Object();
//                    json.Message = "Registry Read";
//                    json.Keys = [
//                        "IO/Inputs/din" + channel + "/Desc",
//                        "IO/Inputs/din" + channel + "/$HourMeter",
//                        "IO/Inputs/din" + channel + "/OpenDesc",
//                        "IO/Inputs/din" + channel + "/ClosedDesc",
//                        "IO/Outputs/rout" + channel + "/Desc",
//                        "IO/Outputs/rout" + channel + "/$HourMeter",
//                        "IO/Outputs/rout" + channel + "/OpenDesc",
//                        "IO/Outputs/rout" + channel + "/ClosedDesc",
//                    ]
//                    doSend(JSON.stringify(json));
//                }

                $('#blank-cover').fadeOut();
                _loggedIn = true;
            }

            function onClose(evt) {
                $('#overlay-text').html("Connection has been lost");
                $('#message-overlay').fadeIn();

                console.log("Closed");
                setTimeout(function() {
                    init();
                }, 1000);
            }


            var Nonce;
            function onMessage(evt) {
                console.log(new Date().getTime() + "   <-- RECV:   " + evt.data);

                var obj = jQuery.parseJSON(evt.data);
//                $.each(obj, function(key, val) {
//                    console.log(key + ' = ' + val);
//                });


                // if nonce exists then we need to login
                if (obj.Nonce != null && document.cookie.indexOf('JANOS-Session-Id') == -1) {
                    Nonce = obj.Nonce;
                    $('#dialog-login').dialog('open');
                    return;
                } else {
                    if (!_loggedIn)
                        loggedIn();
                }


                if (obj.Message == "Authenticated") {
                    loggedIn();
                }
                else if (obj.Message == 'Monitor')
                    processMonitorPacket(obj);
                else if (obj.Message == 'Registry Response' || obj.Message == 'Registry Update')
                    processRegistryPacket(obj);
                else if (obj.Message == 'Registry List Response')
                    processRegistryListing(obj);
            }


            function buildScreen() {
                if (inputCount > 8) {
                    $('#inputs9_16').show();
                    $('#inputs-header').attr('colspan', '2');
                } else {
                    $('#inputs9_16').hide();
                    $('#inputs-header').attr('colspan', '1');
                }
            }


            /////////////////////////////////////////////
            // Process Monitor Packet
            /////////////////////////////////////////////
            function processMonitorPacket(obj) {
                console.log('Process Monitor Packet');
                $('#os-version').html('OS Version: ' + obj.Version);


                if (obj.Model == "410") {
                    inputCount = 8;
                    outputCount = 8;
                    buildScreen();
                } else if (obj.Model == "412") {
                    inputCount = 4;
                    outputCount = 12;
                    buildScreen();
                } else if (obj.Model == "414") {
                    inputCount = 12;
                    outputCount = 4;
                    buildScreen();
                }


                if (obj.Inputs.length < 16) {
                    for (var channel = obj.Inputs.length; channel < 16; channel++) {
                        var stateElement = $('#din' + (channel + 1) + '_state');

//                        stateElement.html('- -');
                        stateElement.attr('class', 'io-state');

                        stateElement.parent().parent().attr('class', 'io-channel-empty');
                        stateElement.parent().hide();
                        stateElement.parent().next().hide();
                    }
                }


                if (obj.Inputs.length != inputsReceived) {
                    inputsReceived = obj.Inputs.length;

                    for (var channel = 1; channel <= inputsReceived; channel++) {
                        json = new Object();
                        json.Message = "Registry Read";
                        json.Keys = [
                            "IO/Inputs/din" + channel + "/Desc",
                            "IO/Inputs/din" + channel + "/$HourMeter",
                            "IO/Inputs/din" + channel + "/OpenDesc",
                            "IO/Inputs/din" + channel + "/ClosedDesc"
                        ]
                        doSend(JSON.stringify(json));
                    }
                }

                $.each(obj.Inputs, function(channel, input) {
                    var stateElement = $('#din' + (channel + 1) + '_state');

                    if (channel < inputCount) {
                        if (input.State == 1) {
                            $('#io_inputs_din' + (channel + 1) + '_opendesc').hide();
                            $('#io_inputs_din' + (channel + 1) + '_closeddesc').show();
                            stateElement.attr('class', 'io-state io-closed');
                        } else {
                            $('#io_inputs_din' + (channel + 1) + '_opendesc').show();
                            $('#io_inputs_din' + (channel + 1) + '_closeddesc').hide();
                            stateElement.attr('class', 'io-state io-open');
                        }

                        var countElement = $('#din' + (channel + 1) + '_count');
                        countElement.html(input.Count);
                    }
                });


                var show9_16 = false;

                if (obj.Outputs.length != outputsReceived) {
                    outputsReceived = obj.Outputs.length;

                    for (var channel = 1; channel <= outputsReceived; channel++) {
                        json = new Object();
                        json.Message = "Registry Read";
                        json.Keys = [
                            "IO/Outputs/rout" + channel + "/Desc",
                            "IO/Outputs/rout" + channel + "/$HourMeter",
                            "IO/Outputs/rout" + channel + "/OpenDesc",
                            "IO/Outputs/rout" + channel + "/ClosedDesc"
                        ]
                        doSend(JSON.stringify(json));
                    }
                }

                if (obj.Outputs.length < 16) {
                    for (var channel = obj.Outputs.length; channel < 16; channel++) {
                        var stateElement = $('#rout' + (channel + 1) + '_state');

//                        stateElement.html('- -');
                        stateElement.attr('class', 'io-state');
//
                        stateElement.parent().parent().attr('class', 'io-channel-empty');
                        stateElement.parent().hide();
                        stateElement.parent().next().hide();
                    }
                }

                $.each(obj.Outputs, function(channel, output) {
                    var stateElement = $('#rout' + (channel + 1) + '_state');

                    if (output != null) {
                        stateElement.parent().parent().attr('class', 'io-channel');
                        stateElement.parent().show();
                        stateElement.parent().next().show();


                        if (channel >= 8)
                            show9_16 = true;

                        if (output.State == 1) {
                            $('#io_outputs_rout' + (channel + 1) + '_opendesc').hide();
                            $('#io_outputs_rout' + (channel + 1) + '_closeddesc').show();
                            stateElement.attr('class', 'io-state io-closed');
                        } else {
                            $('#io_outputs_rout' + (channel + 1) + '_opendesc').show();
                            $('#io_outputs_rout' + (channel + 1) + '_closeddesc').hide();
                            stateElement.attr('class', 'io-state io-open');
                        }
                    } else {
//                        stateElement.html('- -');
                        stateElement.attr('class', 'io-state');
//
                        stateElement.parent().parent().attr('class', 'io-channel-empty');
                        stateElement.parent().hide();
                        stateElement.parent().next().hide();
                    }
                });

                if (show9_16) {
                    $('#outputs9_16').show();
                    $('#outputs-header').attr('colspan', '2');
                } else {
                    $('#outputs9_16').hide();
                    $('#outputs-header').attr('colspan', '1');
                }
            }


            /////////////////////////////////////////////
            // Process Registry Packet
            /////////////////////////////////////////////
            function processRegistryPacket(obj) {
                console.log('Process Registry Packet');

                $.each(obj.Keys, function(key, val) {
                    console.log('   ' + key + ' = ' + val);

                    var elementId = key.replaceAll('/', '_');
                    elementId = elementId.replaceAll('$', '_');
                    elementId = elementId.toLowerCase();
                    console.log("element id: " + elementId);

//					while (elementId[0] == '_') elementId = elementId.substring(1);

                    if (key == "$Model") {
                        $('#model-num').html(val);
                        $('#model-num2').html(val);


                        if (val == "410") {
                            inputCount = 8;
                            outputCount = 8;
                            buildScreen();
                        } else if (val == "412") {
                            inputCount = 4;
                            outputCount = 12;
                            buildScreen();
                        } else if (val == "414") {
                            inputCount = 12;
                            outputCount = 4;
                            buildScreen();
                        }


                        for (var i = outputCount; i < 16; i++) {
                            $('#io_outputs_rout' + (i + 1) + '__hourmeter').parent().hide();
                        }

                    } else if (key == "Externals/DeviceOrder/TypeFB_1" && val != null) {
                        outputCount += 4;
                        buildScreen();
                    } else if (key == "Externals/DeviceOrder/TypeFB_2" && val != null) {
                        outputCount += 4;
                        buildScreen();
                    }


                    if (val != null) {
                        $('#' + elementId).html(val);
                        $('#' + elementId).attr('title', val);
                    }

                });

            }



            /////////////////////////////////////////////
            // Process Registry Listing
            /////////////////////////////////////////////
            function processRegistryListing(obj) {
                console.log('Process Registry Listing');

                $.each(obj.Keys, function(index, key) {
                    console.log('   ' + index + ' = ' + key);


                    if (key.endsWith('/')) {
                        removeRegistryContents(key.substring(0, key.length - 1), false);
                    }
                });

            }



            function endsWith(str, suffix) {
                return str.indexOf(suffix, str.length - suffix.length) !== -1;
            }


            function onError(evt) {
                console.log("Error " + evt.data);
//                alert('disconnected');
            }


            function sendHeartbeat() {
                doSend('');
            }


            function doSend(message) {
                if (message != '') {
                    console.log(new Date().getTime() + "   SEND -->:   " + message);
                }
                websocket.send(message);
                _lastMessage = message;
            }



            $(document).ready(function() {
                buildDialogs();

//                // check for JANOS-SessionId cookie
//                if (document.cookie.indexOf('JANOS-Session-Id') == -1) {
//                    $('#dialog-login').dialog('open');
//                } else {
//                    $('#blank-cover').fadeOut();
//                }


                // we need to periodically send a 'heartbeat' to the jnior websocket connection
                window.setInterval('sendHeartbeat();', 15000);

                $("body").disableSelection();

                $('.control-menu').menu();

                $('#menu').click(function() {
                    $('.left-float-menu').show('slide');
                });

                $('#inputs9_16').hide();
                $('#inputs-header').attr('colspan', '1');

                $('#outputs9_16').hide();
                $('#outputs-header').attr('colspan', '1');

                $('#chk-inputs-9_16').change(function() {
                    if ($(this).is(':checked')) {
                        $('#inputs9_16').show();
                        $('#inputs-header').attr('colspan', '2');
                    } else {
                        $('#inputs9_16').hide();
                        $('#inputs-header').attr('colspan', '1');
                    }
                });


                // whenever there is a mouse up event we must make sure that the context menu gets hidden
                $(document).bind("mouseup", function(e) {
                    $('.control-menu').hide();
                    $('.left-float-menu').hide('slide');
                });


                $('#close-float-menu').click(function() {
                    $('.left-float-menu').hide('slide');
                });

                $('.left-float-menu').bind('mouseup', function(event) {
                    event.stopPropagation();
                });


                $(".toggle").click(function() {
                    json = new Object();
                    json.Message = "Control";
                    json.Command = "Toggle";
                    json.Channel = this.id;
                    doSend(JSON.stringify(json));
                });

                $('.toggle').bind("contextmenu", function(e) {
                    var parentDiv = $(this).closest('.io-channel');
                    var channel = parentDiv.attr('id').substring(parentDiv.attr('id').indexOf('-') + 1);

                    $('#io-control-menu-' + channel).show();
                    return false;
                });


                $(".close").click(function() {
                    json = new Object();
                    json.Message = "Control";
                    json.Command = "Close";
                    json.Channel = this.id;
                    doSend(JSON.stringify(json));
                });

                $(".close-pulse").click(function() {
                    var parentDiv = $(this).closest('.io-channel');
                    var channel = parentDiv.attr('id').substring(parentDiv.attr('id').indexOf('-') + 1);

                    var duration = prompt("Enter a duration for the Close Pulse of channel " + channel, "1000");
                    if (duration != null) {
                        json = new Object();
                        json.Message = "Control";
                        json.Command = "Close";
                        json.Channel = this.id;
                        json.Duration = duration;
                        doSend(JSON.stringify(json));
                    }
                });

                $(".open").click(function() {
                    json = new Object();
                    json.Message = "Control";
                    json.Command = "Open";
                    json.Channel = this.id;
                    doSend(JSON.stringify(json));
                });


                //
                // fucntion to prompt the user for a duration in which the output should be pulsed low.
                // Upon a valid duration the command will be executed on the JNIOR
                //
                $(".open-pulse").click(function() {
                    var parentDiv = $(this).closest('.io-channel');
                    var channel = parentDiv.attr('id').substring(parentDiv.attr('id').indexOf('-') + 1);

                    var duration = prompt("Enter a duration for the Open Pulse of channel " + channel, "1000");
                    if (duration != null) {
                        json = new Object();
                        json.Message = "Control";
                        json.Command = "Open";
                        json.Channel = this.id;
                        json.Duration = duration;
                        doSend(JSON.stringify(json));
                    }
                });





                //
                // function to prompt the user for a new device description and send the command to write
                // the registry key when the edit link is clicked
                //
                $('#device_desc').dblclick(function() {
                    var newDesc = prompt("Enter new Device Description", $('#device_desc').html());
                    if (newDesc != null) {
                        json = new Object();
                        json.Message = "Registry Write";
                        json.Keys = {"Device/Desc": newDesc};
                        doSend(JSON.stringify(json));
                    }
                });


                //
                // function to prompt the user for a new io description and send the command to write
                // the registry key when the edit link is clicked
                //
                $('.io-description').dblclick(function() {
                    var parentDiv = $(this).closest('.io-channel');
                    var channel = parentDiv.attr('id').substring(parentDiv.attr('id').indexOf('-') + 1);

                    var descriptionSpan = $(this).find('span');
                    var newDesc = prompt("Enter new Description for Channel " + channel, descriptionSpan.html());
                    if (newDesc != null) {
                        json = new Object();
                        json.Message = "Registry Write";

                        var keyValueJson = new Object();
                        if (descriptionSpan.attr('id').indexOf('inputs') > 0) {
                            keyValueJson["IO/Inputs/din" + channel + "/Desc"] = newDesc;
                        } else if (descriptionSpan.attr('id').indexOf('outputs') > 0) {
                            keyValueJson["IO/Outputs/rout" + channel + "/Desc"] = newDesc;
                        }
                        json.Keys = keyValueJson;

                        doSend(JSON.stringify(json));
                    }
                    return;
                });


                //
                // function to prompt the user for a new io state description and send the command to write
                // the registry key when the edit link is clicked
                //
                $('.io-state').dblclick(function() {
                    var parentDiv = $(this).closest('.io-channel');
                    var channel = parentDiv.attr('id').substring(parentDiv.attr('id').indexOf('-') + 1);

                    var newDesc = prompt("Enter new Description for the OPEN state for Channel " + channel, $(this).find('[id$=OpenDesc]').html());
                    if (newDesc != null) {
                        json = new Object();
                        json.Message = "Registry Write";

                        var keyValueJson = new Object();
                        if ($(this).attr('id').indexOf('din') >= 0) {
                            keyValueJson["IO/Inputs/din" + channel + "/OpenDesc"] = newDesc;
                        } else if ($(this).attr('id').indexOf('rout') >= 0) {
                            keyValueJson["IO/Outputs/rout" + channel + "/OpenDesc"] = newDesc;
                        }
                        json.Keys = keyValueJson;

                        doSend(JSON.stringify(json));
                    }

                    newDesc = prompt("Enter new Description for the CLOSED state for Channel " + channel, $(this).find('[id$=ClosedDesc]').html());
                    if (newDesc != null) {
                        json = new Object();
                        json.Message = "Registry Write";

                        var keyValueJson = new Object();
                        if ($(this).attr('id').indexOf('din') >= 0) {
                            keyValueJson["IO/Inputs/din" + channel + "/ClosedDesc"] = newDesc;
                        } else if ($(this).attr('id').indexOf('rout') >= 0) {
                            keyValueJson["IO/Outputs/rout" + channel + "/ClosedDesc"] = newDesc;
                        }
                        json.Keys = keyValueJson;

                        doSend(JSON.stringify(json));
                    }

                    return;
                });


                init();
            });



            ///// Build Dialogs //////////////////////////////////////////////////////////////////////////////////////
            function buildDialogs() {
                $("#dialog-login").dialog({
                    autoOpen: false, width: 350, modal: true,
                    show: {effect: "drop", direction: "up", duration: 250},
                    hide: {effect: "drop", direction: "up", duration: 250},
                    buttons: {
                        OK: function() {
                            var response = new Object();
//							response['Auth-Plain'] = $('#username').val() + ':' + $('#password').val();
//							response['Auth-Basic'] = Base64.encode( $('#username').val() + ':' + $('#password').val() );
                            response['Auth-Digest'] = $('#username').val() + ':' + md5($('#username').val() + ':' + Nonce + ':' + $('#password').val());

                            doSend(JSON.stringify(response));

                            $(this).dialog("close");
                        }
                    },
                    open: function() {
                        $(this).parents('.ui-dialog-buttonpane button:eq(0)').focus();
                        $('#username').val('');
                        $('#password').val('');
                        setTimeout(function() {
                            $('#username').focus();
                        }, 500);
                    },
                    close: function() {
                    },
                    appendTo: "form"
                });
                $('#dialog-login').keypress(function(e) {
                    if (e.keyCode == $.ui.keyCode.ENTER) {
                        var response = new Object();
//						response['Auth-Plain'] = $('#username').val() + ':' + $('#password').val();
//						response['Auth-Basic'] = Base64.encode( $('#username').val() + ':' + $('#password').val() );
                        response['Auth-Digest'] = $('#username').val() + ':' + md5($('#username').val() + ':' + Nonce + ':' + $('#password').val());

                        doSend(JSON.stringify(response));

                        $(this).dialog("close");

                        return false;
                    }
                });
            }



            /**
             * ReplaceAll by Fagner Brack (MIT Licensed)
             * Replaces all occurrences of a substring in a string
             */
            String.prototype.replaceAll = function(token, newToken, ignoreCase) {
                var str, i = -1, _token;
                if ((str = this.toString()) && typeof token === "string") {
                    _token = ignoreCase === true ? token.toLowerCase() : undefined;
                    while ((i = (
                            _token !== undefined ?
                            str.toLowerCase().indexOf(
                            _token,
                            i >= 0 ? i + newToken.length : 0
                            ) : str.indexOf(
                            token,
                            i >= 0 ? i + newToken.length : 0
                            )
                            )) !== -1) {
                        str = str.substring(0, i)
                                .concat(newToken)
                                .concat(str.substring(i + token.length));
                    }
                }
                return str;
            };

        </script>

    </head>

    <body>

        <table align="center">
            <tr>
                <td colspan="4" align="center"><h1 id="device_desc">JNIOR <span id="model-num2"></span></h1></td>
            </tr>
            <tr>
                <th colspan="2" bgcolor="#d0d0d0" id="inputs-header">Inputs</th><th colspan="2" bgcolor="#d0d0d0" id="outputs-header">Outputs</th>
            </tr>
            <tr>
                <td>
                    <script>
                        for (var i = 0; i < 16; i++) {
                            if (i == 8) {
                                document.writeln('</td><td id="inputs9_16">');
                            }

                            var div;
                            if (i < 8) {
                                div = '<div id="channel-' + (i + 1) + '" class="io-channel">';
                            } else {
                                div = '<div id="channel-' + (i + 1) + '" class="io-channel" style="margin-left: 0px;">';
                            }
                            div += '<div>';
                            div += '<div class="io-description">' + (i + 1) + ' - <span id="io_inputs_din' + (i + 1) + '_desc">Digital Input ' + (i + 1) + '</span></div>';
                            div += '<div id="din' + (i + 1) + '_state" class="io-state io-open"><div id="io_inputs_din' + (i + 1) + '_opendesc">OFF</div><div id="io_inputs_din' + (i + 1) + '_closeddesc" style="display:none">ON</div></div>';
                            div += '</div>';
                            div += '<div style="clear: both;">';
                            div += '<div class="io-counter">Counter: <span id="din' + (i + 1) + '_count">- -</span></div>';
                            div += '<div class="io-usage">Hours: <span id="io_inputs_din' + (i + 1) + '__hourmeter">- -</span></div>';
                            div += '</div>';
                            div += '</div>';
                            document.writeln(div);
                        }
                    </script>
                </td>

                <!-- OUTPUTS -->
                <td>
                    <script>
                        for (var i = 0; i < 16; i++) {
                            if (i == 8) {
                                document.writeln('</td><td id="outputs9_16">');
                            }

                            var div;
                            if (i < 8) {
                                div = '<div id="channel-' + (i + 1) + '" class="io-channel">';
                            } else {
                                div = '<div id="channel-' + (i + 1) + '" class="io-channel" style="margin-left: 0px;">';
                            }
                            div += '<div>';
                            div += '<div class="io-description">' + (i + 1) + ' - <span id="io_outputs_rout' + (i + 1) + '_desc">Relay Output ' + (i + 1) + '</span></div>';
                            div += '<div id="rout' + (i + 1) + '_state" class="io-state"><div id="io_outputs_rout' + (i + 1) + '_opendesc">OFF</div><div id="io_outputs_rout' + (i + 1) + '_closeddesc" style="display:none">ON</div></div>';
                            div += '<div class="io-control"><button id="' + (i + 1) + '" class="toggle" style="height:100%; width: 100%">Toggle</button>';
                            div += '<ul id="io-control-menu-' + (i + 1) + '" class="control-menu" style="display:none;">';
                            div += '<li id="' + (i + 1) + '" class="close"><a href="#">Close</a></li>';
                            div += '<li id="' + (i + 1) + '" class="close-pulse"><a href="#">Close Pulse</a></li>';
                            div += '<li id="' + (i + 1) + '" class="open"><a href="#">Open</a></li>';
                            div += '<li id="' + (i + 1) + '" class="open-pulse"><a href="#">Open Pulse</a></li>';
                            div += '</ul>';
                            div += '</div>';
                            div += '</div>';
                            div += '<div style="clear: both;">';
                            div += '<div class="io-counter"></div>';
                            div += '<div class="io-usage">Hours: <span id="io_outputs_rout' + (i + 1) + '__hourmeter">- -</span></div>';
                            div += '</div>';
                            div += '</div>';
                            document.writeln(div);
                        }
                    </script>
                </td>


            </tr>
            <tr>
                <td id="os-version" class="small-grey" style="padding-top:15px;padding-bottom:0px;"></td>
                <!-- <td colspan="3" align="right" class="small-grey"><a href="javascript:void(0);" id="close-all" class="highlight">Close All</a> | <a href="javascript:void(0);" id="close-all" class="highlight">Open All</a></td> -->
            </tr>
            <tr>
                <td class="small-grey" style="padding-top:5px;">Serial Number: <span id="_serialnumber"></span></td>
            </tr>
        </table>
        <br><br><br>


        <div id="menu" style="position : fixed; left:10px; top:40%;"><a href="javascript:void(0);" class="highlight"><b><< Show Menu</b></a></div>
        <div class="left-float-menu" style="display: none">
            <div style="float: right;"><a href="javascript:void(0);" id="close-float-menu" class="highlight">close</a></div>
            <div style="padding-top:75px;">
                <h3>Links</h3>
                <p>Click on the following to go to the</p>
                <p><a href="/configure" id="close-all" class="highlight" target="_blank" title="This is the old monitor, configure, and control web page">Classic Configuration Page</a></p>
                <p><a href="/task" id="close-all" class="highlight" target="_blank">Task Manager Page</a></p>

                <?php
                $name = "\\flash\\www\\events\\index.html";
                if (fileExists($name)) {
                    echo "<p><a href=\"/events\" id=\"close-all\" class=\"highlight\" target=\"_blank\">Event Manager Page</a></p>";
                }
                ?>

            </div>
            <div style="padding-top:75px;">
                <h3>Tips</h3>
                <p><b>Edit Descriptions</b></p><p>Double click on a Device Description, I/O Description or I/O State Description that you would like to edit.</p>
                <p><b>More I/O Control</b></p><p>Right click on a Toggle Button to get options to Close, Open or Pulse.</p>
            </div>
        </div>

        <div class="lower-left-float"><p><a href="http://www.integpg.com" target="_blank" class="highlight">INTEG Process Group, Inc.</a></p></div>
        <!-- 1./*++*/0./****/8./*//*/0 -->
        <div class="lower-right-float"><p class="highlight">Web Version 1.0.8.0</p></div>


        <div id="message-overlay" class="message-overlay" style="display: none;">
            <div id="overlay-text" class="overlay-text"></div>
        </div>



        <div id="dialog-login" title="Enter Login Information">
            <table style="padding: 25px;font-size:12px;">
                <tr>
                    <td align="right">
                        User Name:
                    </td>
                    <td>
                        <input type="text" id="username" />
                    </td>
                </tr>
                <tr>
                    <td align="right">
                        Password:
                    </td>
                    <td>
                        <input type="password" id="password" />
                    </td>
                </tr>
                <tr id="logging-in" style="display: none">
                    <td colspan="2" style="color: green">
                        Logging in...
                    </td>
                </tr>
                <tr id="login-error" style="display: none">
                    <td colspan="2" style="color: red">
                        <span id="login-error-info"></span>
                    </td>
                </tr>
            </table>
        </div>


        <div id="blank-cover" style="position: fixed;top: 0;left: 0;width: 100%;height: 100%;background: #f0f0f0;text-align:center;display:table;" style="display: none;">
            <div style="color:#aaaaaa;font:12px arial,sans-serif;font-weight:bold;display: table-cell;vertical-align: middle;">You must be logged in<br>Click <a href="javascript: void(0)" onclick="$('#dialog-login').dialog('open');" style="color:#666666">here</a> to login</div>
        </div>
    </body>

</html>